<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { ref, watch, onMounted, inject } from 'vue';
import { storeToRefs } from 'pinia';
import PersonGridItem from '@/components/chat/PersonsGridItem.vue';
import ChatGridItem from '@/components/chat/ChatGridItem.vue';
import { request } from '@/lib/request';
import type { Chat, Person } from '@/types/chat';
import { useChatStore } from '@/stores/chat';

const configuration = inject<any>('configuration');
const chatStore = useChatStore();
const { state } = storeToRefs(chatStore);
const persons = ref<Person[]>([]);
const chats = ref<Chat[]>([]);
const loaded = ref(false);

onMounted(async () => {
    await getData();
    loaded.value = true;
});

const getData = async () => {
    const result = await request('GET', configuration.apiServer + "/api/ai/overview", undefined, undefined, false, true);
    if (result.success) {
        persons.value = result.persons.map((person: Person) => { return { name: person.name, categories: person.categories, systemprompt: person.system_prompt, avatar: person.avatar, uuid: person.uuid, description: person.description, username: person.username, model: person.model } });
        chats.value = result.chats.map((chat: Chat) => { return { name: chat.name, avatar: chat.avatar, image: chat.type === 'image', message: chat.message, uuid: chat.uuid, person: chat.person } });
    }
};

watch(() => state.value, (newVal, oldVal) => {
    if (oldVal !== "" && newVal === '') {
        getData();
    }
});

</script>
<template>
    <div class="flex flex-col gap-8 h-full select-none max-h-[calc(100dvh-7.5rem)] overflow-auto">
        <div class="inline-block box-border">
            <h1 class="text-3xl text-gray-600 mb-4">{{ $t('ai.chat.newest.label') }}</h1>
            <div class="flex flex-row gap-4 overflow-x-auto overflow-y-hidden w-full">
                <ChatGridItem :key="`chat_` + chat.name" :name="chat.name" :person="chat.person!"
                    :message="chat.message!" :image="chat.image" :avatar="chat.avatar" :uuid="chat.uuid"
                    v-for="chat in chats" v-if="chats.length > 0" />
                <div class="text-lg text-gray-400 text-center w-full min-h-20 flex flex-col justify-center" v-else>
                    <div v-if="loaded">{{ $t('ai.chat.noAvailable.label') }}</div>
                    <div class="rounded-md p-4 max-w-sm w-full mx-auto" v-else>
                        <div class="animate-pulse flex space-x-4">
                            <div class="rounded-full bg-slate-700 h-10 w-10"></div>
                            <div class="flex-1 space-y-6 py-1">
                                <div class="h-2 bg-slate-700 rounded"></div>
                                <div class="space-y-3">
                                    <div class="grid grid-cols-3 gap-4">
                                        <div class="h-2 bg-slate-700 rounded col-span-2"></div>
                                        <div class="h-2 bg-slate-700 rounded col-span-1"></div>
                                    </div>
                                    <div class="h-2 bg-slate-700 rounded"></div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="inline-block box-border">
            <h1 class="text-3xl text-gray-600 mb-4">{{ $t('ai.person.newest.label') }}</h1>
            <div class="flex flex-row gap-4 overflow-x-auto overflow-y-hidden w-full">
                <PersonGridItem :key="`person_` + person.name" :name="person.name" :username="person.username"
                    :shared="true" :uuid="person.uuid" :description="person.description" :categories="person.categories"
                    :systemprompt="person.systemprompt" :avatar="person.avatar" :model="person.model" v-for="person in persons"
                    v-if="persons.length > 0" />
                <div class="text-lg text-gray-400 text-center w-full min-h-20 flex flex-col justify-center" v-else>
                    <div v-if="loaded">{{ $t('ai.person.noAvailable.label') }}</div>
                    <div class="rounded-md p-4 max-w-sm w-full mx-auto" v-else>
                        <div class="animate-pulse flex space-x-4">
                            <div class="rounded-full bg-slate-700 h-10 w-10"></div>
                            <div class="flex-1 space-y-6 py-1">
                                <div class="h-2 bg-slate-700 rounded"></div>
                                <div class="space-y-3">
                                    <div class="grid grid-cols-3 gap-4">
                                        <div class="h-2 bg-slate-700 rounded col-span-2"></div>
                                        <div class="h-2 bg-slate-700 rounded col-span-1"></div>
                                    </div>
                                    <div class="h-2 bg-slate-700 rounded"></div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </div>
</template>